<?php
	if(!isset($_SESSION)) {session_start();}
	/*
	 * Script:    DataTables server-side script for PHP and MySQL
	 * Copyright: 2010 - Allan Jardine
	 * License:   GPL v2 or BSD (3-point)
	 */
	
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Easy set variables
	 */
	
	/* Array of database columns which should be read and sent back to DataTables. Use a space where
	 * you want to insert a non-database field (for example a counter or static image)
	 */
	$aColumns = array( 'device_key','device_name','trolley_id','picklist','device_status','push_picklist','remove_picklist','delete_device');
	
//$aColumnsFilter = array( 'product_code', 'product_ref',  'product_name', 'product_price', 'product_sale_price');
	
	/* Indexed column (used for fast and accurate table cardinality) */
	$sIndexColumn = "device_key";
	
	/* DB table to use */
	$sTable = "devices_view_incomplete";
	
	/* Database connection information */
	include("repcon.php");
	
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * If you just want to use the basic configuration for DataTables with PHP server-side, there is
	 * no need to edit below this line
	 */
	
	/* 
	 * MySQL connection
	 */
	$gaSql['link'] =  mysql_pconnect( $gaSql['server'], $gaSql['user'], $gaSql['password']  ) or
		die( 'Could not open connection to server' );
	
	mysql_select_db( $gaSql['db'], $gaSql['link'] ) or 
		die( 'Could not select database '. $gaSql['db'] );
	
	
	/* 
	 * Paging
	 */
	$sLimit = "";
	if ( isset( $_GET['iDisplayStart'] ) && $_GET['iDisplayLength'] != '-1' )
	{
		$sLimit = "LIMIT ".mysql_real_escape_string( $_GET['iDisplayStart'] ).", ".
			mysql_real_escape_string( $_GET['iDisplayLength'] );
	}
	
	
	/*
	 * Ordering
	 */
	if ( isset( $_GET['iSortCol_0'] ) )
	{
		$sOrder = "ORDER BY  ";
		for ( $i=0 ; $i<intval( $_GET['iSortingCols'] ) ; $i++ )
		{
			if ( $_GET[ 'bSortable_'.intval($_GET['iSortCol_'.$i]) ] == "true" )
			{
				$sOrder .= $aColumns[ intval( $_GET['iSortCol_'.$i] ) ]."
				 	".mysql_real_escape_string( $_GET['sSortDir_'.$i] ) .", ";
			}
		}
		
		$sOrder = substr_replace( $sOrder, "", -2 );
		if ( $sOrder == "ORDER BY" )
		{
			$sOrder = "";
		}
	}
	
	
	/* 
	 * Filtering
	 * NOTE this does not match the built-in DataTables filtering which does it
	 * word by word on any field. It's possible to do here, but concerned about efficiency
	 * on very large tables, and MySQL's regex functionality is very limited
	 */
	// $search_category = $_GET['search_category'];
	
	// $srch = $_GET['sSearch'];
	// $cdate = $_REQUEST["cdate"];
	// $edate = $_REQUEST["edate"];
	// $status = $_REQUEST["status"];
	// $courier_name = $_REQUEST["courier_name"];
	// if($courier_name == 'MNP'){$courier_name = "M&P";}
	// $sWhere = "WHERE order_date between str_to_date('$cdate','%d/%m/%Y') and str_to_date('$edate','%d/%m/%Y')";
	
	// if ($status == "1" )
	// {$sWhere .= " AND picklist_id IS NOT NULL ";}
	
	// if ($status == "2" )
	// {$sWhere .= " AND picklist_id NULL ";}
	
	// if($courier_name != '0'){
	//  $sWhere .= " AND courier_name = '$courier_name' ";   
	    
	// }
	
	$sWhere = " WHERE device_key  IN ('6129e8f1a22cb3d7','47cbd0a106f6dc7a','eecbda6a6415b62f','5df291a51daff6b9','52db8948bd32beb1','81389354e6176737')";
	
	
	if ( $_GET['sSearch'] != "" )
	{
	$sWhere .= " AND (device_key like '%$srch%' OR device_name like '%$srch%' OR trolley_id like '%$srch%' OR device_type like '%$srch%' OR picklist like '%$srch%' OR device_status like '%$srch%') ";
		
	}
	
	
	/* Individual column filtering */
	for ( $i=0 ; $i<count($aColumns) ; $i++ )
	{
		if ( $_GET['bSearchable_'.$i] == "true" && $_GET['sSearch_'.$i] != '' )
		{
			if ( $sWhere == "" )
			{
				$sWhere = "WHERE ";
			}
			else
			{
				$sWhere .= " AND ";
			}
			$sWhere .= $aColumns[$i]." LIKE '%".mysql_real_escape_string($_GET['sSearch_'.$i])."%' ";
		}
	}
	
	
	/*
	 * SQL queries
	 * Get data to display
	 */
	$sQuery = "
		SELECT SQL_CALC_FOUND_ROWS ".str_replace(" , ", " ", implode(", ", $aColumns))."
		FROM   $sTable
		$sWhere
		$sOrder
		$sLimit
	";
	$rResult = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());
	
	/* Data set length after filtering */
	$sQuery = "
		SELECT FOUND_ROWS()
	";
	$rResultFilterTotal = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());
	$aResultFilterTotal = mysql_fetch_array($rResultFilterTotal);
	$iFilteredTotal = $aResultFilterTotal[0];
	
	/* Total data set length */
	$sQuery = "
		SELECT COUNT(".$sIndexColumn.")
		FROM   $sTable
	";
	$rResultTotal = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());
	$aResultTotal = mysql_fetch_array($rResultTotal);
	$iTotal = $aResultTotal[0];
	
	
	/*
	 * Output
	 */
	$output = array(
		"sEcho" => intval($_GET['sEcho']),
		"iTotalRecords" => $iTotal,
		"iTotalDisplayRecords" => $iFilteredTotal,
		"aaData" => array()
	);
	
	while ( $aRow = mysql_fetch_array( $rResult ) )
	{
		$row = array();
		for ( $i=0 ; $i<count($aColumns) ; $i++ )
		{
			
			$push = '';
$pick = '';
$list = '';  
$exp = explode(',',$aRow[ $aColumns[3] ]);
foreach($exp as $value){
$product_query = mysql_query( "SELECT count(DISTINCT customer_order_no) as order_count FROM `inward_detail` Where picklist_id = '".$value."'
	
	", $gaSql['link'] ) or die(mysql_error());
   $product_run = mysql_fetch_assoc($product_query);
   
   $product_querys = mysql_query( "SELECT  order_date,count(DISTINCT customer_order_number)as odcount FROM customer_order Where picklist_id = '".$value."' GROUP BY picklist_id", $gaSql['link'] ) or die(mysql_error());
   $product_runs = mysql_fetch_assoc($product_querys);
					
					$pick.= "<a href='javascript:void(0);' onclick='Removepicklist(\"".$value."\", event);' title='Removepicklist'>Remove picklist(".$value.")</a><br/>";	
					 if($product_run['order_count'] != $product_runs['odcount']){
                    $list.= $value." -- SkuOut ( ".$product_runs['order_date']." )<br/>";
						
						$push.= "<a href='javascript:void(0);' onclick='PushOrderIncom(\"".$value."\", event);' title='Push Order'>Push Picklist(".$value.")</a><br/>"; 
						}else{
						//$push.=	$value.'<br/>';
						}
				}
			
			if( $aColumns[$i] == "push_picklist")
			{
				//query for product details 
				
				
					
					$row[] = $push;
			
			}
			else if( $aColumns[$i] == "remove_picklist")
			{
				 
						
					$row[] = $pick;
			
			}
			else if( $aColumns[$i] == "delete_device")
			{
				
						$cnlist = "<a href='javascript:void(0);' onclick='Deletedevice(\"".$aRow[ $aColumns[0] ]."\",\"".$aRow[ $aColumns[3] ]."\", event);' title='Deletedevice'>Delete Device</a>
						"; 
						
					$row[] = $cnlist;
			
			}
			else if( $aColumns[$i] == "picklist")
			{
				
				$row[] = $list;
			}
			else if ( $aColumns[$i] != ' ')
			{
				
				$row[] = $aRow[ $aColumns[$i] ];
			}
		}
		$output['aaData'][] = $row;
	}
	
	echo json_encode( $output );
?>