<?php
	if(!isset($_SESSION)) {session_start();}
	/*
	 * Script:    DataTables server-side script for PHP and MySQL
	 * Copyright: 2010 - Allan Jardine
	 * License:   GPL v2 or BSD (3-point)
	 */
	
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * Easy set variables
	 */
	
	/* Array of database columns which should be read and sent back to DataTables. Use a space where
	 * you want to insert a non-database field (for example a counter or static image)
	 */
	$aColumns = array( 'order_date','customer_order_id','newno','customer_billing_name',
	'customer_bill_city','picklist_id','bintype','payment_type','courier_name','codamount','order_status','customer_order_quantity','bincount','cancel_status','dispatch_status','tracking_status','customer_order_date','order_assign_time','picklist_complete_time','scan_time');
	
//$aColumnsFilter = array( 'product_code', 'product_ref',  'product_name', 'product_price', 'product_sale_price');
	
	/* Indexed column (used for fast and accurate table cardinality) */
	$sIndexColumn = "newno";
	
	/* DB table to use */
	$sTable = "orderlist_status_view";
	
	/* Database connection information */
	include("repcon.php");
	
	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	 * If you just want to use the basic configuration for DataTables with PHP server-side, there is
	 * no need to edit below this line
	 */
	
	/* 
	 * MySQL connection
	 */
	$gaSql['link'] =  mysql_pconnect( $gaSql['server'], $gaSql['user'], $gaSql['password']  ) or
		die( 'Could not open connection to server' );
	
	mysql_select_db( $gaSql['db'], $gaSql['link'] ) or 
		die( 'Could not select database '. $gaSql['db'] );
	
	
	/* 
	 * Paging
	 */
	$sLimit = "";
	if ( isset( $_GET['iDisplayStart'] ) && $_GET['iDisplayLength'] != '-1' )
	{
		$sLimit = "LIMIT ".mysql_real_escape_string( $_GET['iDisplayStart'] ).", ".
			mysql_real_escape_string( $_GET['iDisplayLength'] );
	}
	
	
	/*
	 * Ordering
	 */
	if ( isset( $_GET['iSortCol_0'] ) )
	{
		$sOrder = "ORDER BY  ";
		for ( $i=0 ; $i<intval( $_GET['iSortingCols'] ) ; $i++ )
		{
			if ( $_GET[ 'bSortable_'.intval($_GET['iSortCol_'.$i]) ] == "true" )
			{
				$sOrder .= $aColumns[ intval( $_GET['iSortCol_'.$i] ) ]."
				 	".mysql_real_escape_string( $_GET['sSortDir_'.$i] ) .", ";
			}
		}
		
		$sOrder = substr_replace( $sOrder, "", -2 );
		if ( $sOrder == "ORDER BY" )
		{
			$sOrder = "";
		}
	}
	
	
	/* 
	 * Filtering
	 * NOTE this does not match the built-in DataTables filtering which does it
	 * word by word on any field. It's possible to do here, but concerned about efficiency
	 * on very large tables, and MySQL's regex functionality is very limited
	 */
	$search_category = $_GET['search_category'];
	
	$srch = $_GET['sSearch'];
	$cdate = $_REQUEST["cdate"];
	$edate = $_REQUEST["edate"];
	$status = $_REQUEST["status"];
	
	
	$courier_name = $_REQUEST["courier_name"];
	$dispatch_status = $_REQUEST["dispatch_status"];
	if($courier_name == 'MNP'){$courier_name = "M&P";}
	
	$sWhere = "WHERE order_date between str_to_date('$cdate','%d/%m/%Y') and str_to_date('$edate','%d/%m/%Y')";
	
	if ($status != '0')
	{$sWhere .= " AND order_status = '$status' ";}
	
	if ($dispatch_status != '0')
	{$sWhere .= " AND dispatch_status = '$dispatch_status' ";}
	
	
	
	if($courier_name != '0'){
	 $sWhere .= " AND courier_name = '$courier_name' ";   
	    
	}
	
	if ( $_GET['sSearch'] != "" )
	{
	$sWhere .= " AND (order_status like '%$srch%' OR order_date like '%$srch%' OR picklist_complete_time like '%$srch%' OR customer_order_id like '%$srch%' OR newno like '%$srch%' OR customer_billing_name like '%$srch%' OR customer_bill_city like '%$srch%' OR customer_order_quantity like '%$srch%' OR picklist_id like '%$srch%' OR bintype like '%$srch%' OR payment_type like '%$srch%' OR courier_name like '%$srch%' OR codamount like '%$srch%' OR cancel_status like '%$srch%' OR dispatch_status like '%$srch%') ";
		
	}
	
	
	/* Individual column filtering */
	for ( $i=0 ; $i<count($aColumns) ; $i++ )
	{
		if ( $_GET['bSearchable_'.$i] == "true" && $_GET['sSearch_'.$i] != '' )
		{
			if ( $sWhere == "" )
			{
				$sWhere = "WHERE ";
			}
			else
			{
				$sWhere .= " AND ";

			}
			$sWhere .= $aColumns[$i]." LIKE '%".mysql_real_escape_string($_GET['sSearch_'.$i])."%' ";
		}
	}
	
	
	/*
	 * SQL queries
	 * Get data to display
	 */
	$sQuery = "
		SELECT SQL_CALC_FOUND_ROWS ".str_replace(" , ", " ", implode(", ", $aColumns))."
		FROM   $sTable
		$sWhere
		$sOrder
		$sLimit
	";
	$rResult = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());
	
	/* Data set length after filtering */
	$sQuery = "
		SELECT FOUND_ROWS()
	";
	$rResultFilterTotal = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());
	$aResultFilterTotal = mysql_fetch_array($rResultFilterTotal);
	$iFilteredTotal = $aResultFilterTotal[0];
	
	/* Total data set length */
	$sQuery = "
		SELECT COUNT(".$sIndexColumn.")
		FROM   $sTable
	";
	$rResultTotal = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());
	$aResultTotal = mysql_fetch_array($rResultTotal);
	$iTotal = $aResultTotal[0];
	
	
	/*
	 * Output
	 */
	$output = array(
		"sEcho" => intval($_GET['sEcho']),
		"iTotalRecords" => $iTotal,
		"iTotalDisplayRecords" => $iFilteredTotal,
		"aaData" => array()
	);
	
	while ( $aRow = mysql_fetch_array( $rResult ) )
	{
		$row = array();
		for ( $i=0 ; $i<count($aColumns) ; $i++ )
		{
		
		     if( $aColumns[$i] == "bincount")
			{
				//query for product details 
				
					 $product_query = mysql_query( "SELECT count(order_bintype) as order_count FROM `inward_detail` Where order_bintype = '{$aRow[ $aColumns[6] ]}' and picklist_id = '{$aRow[ $aColumns[5] ]}'", $gaSql['link'] ) or die(mysql_error());
					$product_run = mysql_fetch_assoc($product_query);
					
						$pickc = "<span style='background-color:green,color:white'>".(($product_run['order_count']))."</span>";
				       
				
					
					$row[] = $pickc;
			
			}
			
			else if( $aColumns[$i] == "action")
			{
				//query for product details 
				
					
						$cnlist = "<a href='javascript:void(0);' onclick='PrintCN(\"".$aRow[ $aColumns[5] ]."\",\"".$aRow[ $aColumns[2] ]."\", event);' title='Print CN'>Print CN</a>
						<a href='javascript:void(0);' onclick='PrintInvoices(\"".$aRow[ $aColumns[5] ]."\",\"".$aRow[ $aColumns[2] ]."\", event);' title='Print'>Print Invoices</a>";
				     
					 if($product_run['order_count'] == 0){
						$cnlist.= "<br/><a href='javascript:void(0);' onclick='PushOrder(\"".$aRow[ $aColumns[5] ]."\",\"".$aRow[ $aColumns[2] ]."\", event);' title='Push Order'>Push Order</a>
						"; 
					 }

					 $cnlist.= "<br/><a href='javascript:void(0);' onclick='EditOrder(\"".$aRow[ $aColumns[5] ]."\",\"".$aRow[ $aColumns[2] ]."\", event);' title='Edit Order'>Edit Order</a>
						"; 
				
					
					$row[] = $cnlist;
			
			}
			
			
			
			else
			
			 if ( $aColumns[$i] != ' ')
			{
				
				$row[] = $aRow[ $aColumns[$i] ];
			}
		}
		$output['aaData'][] = $row;
	}
	
	echo json_encode( $output );
?>