<?php

	if(!isset($_SESSION)) {session_start();}

	/*

	 * Script:    DataTables server-side script for PHP and MySQL

	 * Copyright: 2010 - Allan Jardine

	 * License:   GPL v2 or BSD (3-point)

	 */

	

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	 * Easy set variables

	 */

	

	/* Array of database columns which should be read and sent back to DataTables. Use a space where

	 * you want to insert a non-database field (for example a counter or static image)

	 */

	$aColumns = array(
		'BARCODE',
		'SKU_NAME',
		'ACTUALPRICE',
		'SALESPRICE',
		'SALESQTY',
		'Discount',
		'SALESUNITSYMBOL',
		'ShipCharges',
		'SHIPWAREHOUSEID',
		'BOOKINGDATE',
		'ORDERNUMBER',
		'CnNumber',
		'C_ADDRESS',
		'C_CITY',
		'C_EMAIL',
		'C_NAME',
		'C_PHONE',
		'VASpay',
		'Courier',
		'RCID'
	);

	

//$aColumnsFilter = array( 'product_code', 'product_ref',  'product_name', 'product_price', 'product_sale_price');

	

	/* Indexed column (used for fast and accurate table cardinality) */

	$sIndexColumn = " inward_detail.sku_id ";

	

	/* DB table to use */

	// $sTable = "return_list";
	$sTable=" return_receive_detail
	INNER JOIN return_receive_master on return_receive_detail.`receive_id` = return_receive_master.`receive_id`
	INNER JOIN inward_detail ON inward_detail.`inward_child` = return_receive_detail.`inward_child`
	INNER JOIN customer_order ON customer_order.customer_order_id = return_receive_detail.`cnno`
	AND customer_order.`sku_id` = inward_detail.`sku_id` ";

	

	/* Database connection information */

	include("repcon.php");

	

	/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

	 * If you just want to use the basic configuration for DataTables with PHP server-side, there is

	 * no need to edit below this line

	 */

	

	/* 

	 * MySQL connection

	 */

	$gaSql['link'] =  mysql_pconnect( $gaSql['server'], $gaSql['user'], $gaSql['password']  ) or

		die( 'Could not open connection to server' );

	

	mysql_select_db( $gaSql['db'], $gaSql['link'] ) or 

		die( 'Could not select database '. $gaSql['db'] );

	/* 

	 * Paging

	 */

	$sLimit = "";

	if ( isset( $_GET['iDisplayStart'] ) && $_GET['iDisplayLength'] != '-1' )

	{

		$sLimit = "LIMIT ".mysql_real_escape_string( $_GET['iDisplayStart'] ).", ".

			mysql_real_escape_string( $_GET['iDisplayLength'] );

	}
	/*

	 * Ordering

	 */

	if ( isset( $_GET['iSortCol_0'] ) )

	{

		$sOrder = " ORDER BY  ";

		for ( $i=0 ; $i<intval( $_GET['iSortingCols'] ) ; $i++ )

		{

			if ( $_GET[ 'bSortable_'.intval($_GET['iSortCol_'.$i]) ] == "true" )

			{

				$sOrder .= $aColumns[ intval( $_GET['iSortCol_'.$i] ) ]."

				 	".mysql_real_escape_string( $_GET['sSortDir_'.$i] ) .", ";

			}

		}

		

		$sOrder = substr_replace( $sOrder, "", -2 );

		if ( $sOrder == " ORDER BY" )

		{

			$sOrder = "";

		}

	}

	

	

	/* 

	 * Filtering

	 * NOTE this does not match the built-in DataTables filtering which does it

	 * word by word on any field. It's possible to do here, but concerned about efficiency

	 * on very large tables, and MySQL's regex functionality is very limited

	 */

	 $search_category = $_GET['search_category'];

	 $srch = $_GET['sSearch'];

	 $cdate = $_REQUEST["cdate"];

	 $edate = $_REQUEST["edate"];

	 $start_time = $_REQUEST["starttime"];

	 $end_time = $_REQUEST["endtime"];

	 $receive_start=$cdate." ".$start_time;

	 $receive_end=$edate." ".$end_time;

	 $courier_name = $_REQUEST["courier_name"];


	if($courier_name == 'MNP'){$courier_name = "M&P";}

	

	// $sWhere = "WHERE date(master_dis_time) between str_to_date('$cdate','%d/%m/%Y') and str_to_date('$edate','%d/%m/%Y')";
	$sWhere=" WHERE receive_time Between '$receive_start' AND '$receive_end' ";

	
	if($courier_name != '0'){

	 $sWhere .= " AND logistics = '$courier_name' ";   

	    

	}

	

	

	if ( $_GET['sSearch'] != "" )

	{

		$sWhere .= " AND (inward_detail.sku_id like '%$srch%' 
		OR customer_order.sku_name like '%$srch%' 
		OR customer_order.actual_price_with_gst like '%$srch%' 
		OR customer_order.singleprice like '%$srch%' 
		-- OR CONCAT('-', COUNT(inward_detail.sku_id)) like '%$srch%' 
		OR (actual_price_with_gst - singleprice) like '%$srch%' 
		-- OR PCS like '%$srch%' 
		-- OR CONCAT('-', customer_order.`shippingcharges`) like '%$srch%' 
		OR customer_order.storeid like '%$srch%' 
		OR customer_order.order_date like '%$srch%'
		OR customer_order.customer_order_number like '%$srch%'
		OR customer_order.customer_order_id like '%$srch%'
		OR customer_order.customer_bill_add like '%$srch%'
		OR customer_order.customer_ship_city like '%$srch%'
		OR customer_order.customer_bill_email like '%$srch%'
		OR customer_order.customer_billing_name like '%$srch%'
		OR customer_order.customer_phone like '%$srch%'
		OR payment_type like '%$srch%'
		OR courier_name like '%$srch%'
		OR return_receive_master.receive_id like '%$srch%'
	) ";

		

	}

	
	/* Individual column filtering */

	for ( $i=0 ; $i<count($aColumns) ; $i++ )

	{

		if ( $_GET['bSearchable_'.$i] == "true" && $_GET['sSearch_'.$i] != '' )

		{

			if ( $sWhere == "" )

			{

				$sWhere = "WHERE ";

			}

			else

			{

				$sWhere .= " AND ";



			}

			$sWhere .= $aColumns[$i]." LIKE '%".mysql_real_escape_string($_GET['sSearch_'.$i])."%' ";

		}

	}

	

	

	/*

	 * SQL queries

	 * Get data to display

	 */

	// $sQuery = "

	// 	SELECT SQL_CALC_FOUND_ROWS ".str_replace(" , ", " ", implode(", ", $aColumns))."

	// 	FROM   $sTable

	// 	$sWhere

	// 	$sOrder

	// 	$sLimit

	// ";

	$sQuery="SELECT SQL_CALC_FOUND_ROWS
	inward_detail.`sku_id` AS BARCODE,
	customer_order.sku_name AS SKU_NAME,
	customer_order.actual_price_with_gst AS ACTUALPRICE,
	customer_order.`singleprice` AS SALESPRICE,
	CONCAT('-', COUNT(inward_detail.sku_id)) AS SALESQTY,
	(actual_price_with_gst - singleprice) AS Discount,
	'PCS' AS SALESUNITSYMBOL,
	CONCAT('-', customer_order.`shippingcharges`) AS ShipCharges,
	customer_order.`storeid` AS SHIPWAREHOUSEID,
	customer_order.`order_date` AS BOOKINGDATE,
	customer_order.`customer_order_number` AS ORDERNUMBER,
	customer_order.`customer_order_id` AS CnNumber,
	customer_order.`customer_bill_add` AS C_ADDRESS,
	customer_order.`customer_ship_city` AS C_CITY,
	customer_order.`customer_bill_email` AS C_EMAIL,
	customer_order.`customer_billing_name` AS C_NAME,
	customer_order.`customer_phone` AS C_PHONE,
	payment_type AS VASpay,
    courier_name AS Courier,
	return_receive_master.receive_id AS RCID
	FROM ";
	$sQuery.=" ";
	$sQuery.=$sTable;
	$sQuery.=" ";
	$sQuery.=$sWhere;
	$sQuery.=" ";

	$sQuery.=" 
	 GROUP BY inward_detail.sku_id, return_receive_detail.cnno ORDER BY return_receive_detail.receive_id,cnno ";

	$sQuery.=" ";
	$sQuery.=$sLimit;

	//  echo($sQuery);

	$rResult = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());

	/* Data set length after filtering */

	$sQuery = "

		SELECT FOUND_ROWS()

	";

	$rResultFilterTotal = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());

	$aResultFilterTotal = mysql_fetch_array($rResultFilterTotal);

	$iFilteredTotal = $aResultFilterTotal[0];

	

	/* Total data set length */

	$sQuery = "

		SELECT COUNT(".$sIndexColumn.")

		FROM   $sTable

	";

	$rResultTotal = mysql_query( $sQuery, $gaSql['link'] ) or die(mysql_error());

	$aResultTotal = mysql_fetch_array($rResultTotal);

	$iTotal = $aResultTotal[0];

	
	/*

	 * Output

	 */

	$output = array(

		"sEcho" => intval($_GET['sEcho']),

		"iTotalRecords" => $iTotal,

		"iTotalDisplayRecords" => $iFilteredTotal,

		"aaData" => array()

	);

	

	while ( $aRow = mysql_fetch_array( $rResult ) )

	{

		$row = array();

		for ( $i=0 ; $i<count($aColumns) ; $i++ )

		{

			 if ( $aColumns[$i] != ' ')

			{
				$row[] = $aRow[ $aColumns[$i] ];

			}

		}

		$output['aaData'][] = $row;

	}

	

	echo json_encode( $output );

?>