<?php

date_default_timezone_set("Asia/Karachi");

/*************************************************************************
Document Type 1 : Item Information
Document Type 2 : Purchase Order of Items
Document Type 3 : Check Available Stock
Document Type 4 : Purchase Order of Items
*************************************************************************/

if(!isset($_SERVER['PHP_AUTH_USER'])){
	header('WWW-Authenticate: Basic realm="benefit"');
	header('HTTP/1.0 401 Unauthorized');
	echo "You must enter a valid login ID and password to access this resource\n";
	exit;
}

$xml = simplexml_load_string(urldecode($_POST['xml']));

$fw = fopen('orderslog/insertfulllogtest' . date('d-m-Y H:i:s') . '.txt', 'w');
fwrite($fw, $xml);
fclose($fw);	

require_once("../inc/dbobjx.php");
$runQuery = new dbObj;
$qry = "INSERT INTO log_file (module,message) VALUES ('OrderProcess','".urldecode($_POST['xml'])."')";
$runQuery->RunQuery($qry);

$doctype =  $xml->AccessRequest->DocumentType;



//echo $doctype;

//////    Document Type 1 - Start

if($doctype==1){
	$SD = $xml->AccessRequest->ItemDetail;
	$errors = 0;
	foreach($SD->Row as $row){
		if($row->SKUID == ''){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>SKUID Missing</message></result>';
			exit;
		}
		elseif($row->Category == ''){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Category Missing</message></result>';
			exit;
		}
		elseif($row->Description == ''){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Description Missing</message></result>';
			exit;
		}
		elseif($row->Cost == ''){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Cost Missing</message></result>';
			exit;
		}
		elseif($row->Price == ''){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Price Missing</message></result>';
			exit;
		}
		
		$Query = "Select IFNULL(max(item_code),0)+1 as item_code
		From item_detail";
		
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		$item_code = $xres->row->item_code; 

		$Query = "Select Count(*) as item_avail
		From item_detail
		Where sku_id = '{$row->SKUID}'";
		
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		$item_avail = $xres->row->item_avail; 

		if($item_avail>=1){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>2</status><message>'.$row->SKUID.' - Already Exist</message></result>';
			exit;
		}
		
		$Query = "Insert Into item_detail 
		(item_code, sku_id, sku_date, update_date, brand, categories, color, description, gender, name,
		size, cost, price, image_link)
		Values
		({$item_code}, '{$row->SKUID}', current_date(), current_date(), '{$row->Brand}', '{$row->Categories}',
		'{$row->Color}', '{$row->Description}', '{$row->Gender}', '{$row->Name}', '{$row->Size}', {$row->Cost},
		{$row->Price},	'{$row->ImageLink}')";
		
		if($runQuery->RunQuery($Query)){}
		else{$errors+=1;}
	}
	if($errors == 0){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>1</status><message>Successfully Received</message></result>';
	}
	else{
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Error! (Not Update)</message></result>';
	}
	exit;
}

//////     Document Type 1 - Closed
	
//////     Document Type 2 - Start

elseif($doctype==2){
	$SD = $xml->AccessRequest->OrderDetail;

	if($SD->OrderNumber == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Order No Missing</message></result>';
		exit;
	}
	elseif($SD->OrderDate == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Order Date Missing</message></result>';
		exit;
	}
	elseif($SD->ETADate == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>ETA Missing</message></result>';
		exit;
	}
	elseif($SD->Supplier == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Supplier Missing</message></result>';
		exit;
	}

	foreach($SD->ItemList->Row as $row){
		$sku_id = $row->ItemCode;
		$Query = "Select Count(*) as item_avail
		From item_detail
		Where sku_id = '{$sku_id}'";
		
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		$item_avail = $xres->row->item_avail; 
	
		if($item_avail==0){
			echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>'.$sku_id.' - Not Found</message></result>';
			exit;
		}
	}
	
	$response = 0;
	foreach($SD->ItemList->Row as $row){
		$sku_id = $row->ItemCode;
		$sku_qty = $row->ItemQuantity;
		$Query = "insert into inward_sku(sku_id, sku_date, order_no, eta_date, brand, categories, 
		color, description,	gender, name, supplier, size, cost, price, quantity, image_link)
		select sku_id, str_to_date('{$SD->OrderDate}','%d/%m/%Y'), '{$SD->OrderNumber}', 
		str_to_date('{$SD->ETADate}','%d/%m/%Y'), brand, categories, color,
		description, gender, name, '{$SD->Supplier}', size, cost, price, 12, image_link
		from item_detail
		where sku_id = '{$sku_id}'";
		
		if($runQuery->RunQuery($Query)){$response=1;}
	}
	if($response == 1){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>1</status><message>Successfully Received</message></result>';
	}
	else{echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Error! (Not Update)</message></result>';}
	exit;
}

//////     Document Type 2 - Closed	
	
//////     Document Type 3 - Start

elseif($doctype==9){
	$SD = $xml->AccessRequest;

	$response = '<?xml version="1.0" encoding="utf-8"?><result>';
	foreach($SD->SKUList->SKUID as $sku_id){
	
		$Query = "SELECT COUNT(*) AS cnt,inward_detail.sku_id, inward_sku.`name`, 
		inward_sku.`description`, inward_sku.`price`, inward_sku.`cost`
		FROM inward_detail JOIN inward_sku ON inward_detail.`inward_id`=inward_sku.`inward_id`
		WHERE binid IS NOT NULL
		AND picklist_id IS NULL
		and inward_detail.sku_id = '{$sku_id}'
		GROUP BY inward_detail.sku_id
		ORDER BY inward_sku.`sku_id`";
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		
		$Query2 = "SELECT SUM(o.customer_order_quantity) AS cnt2 FROM customer_order_test o 
		WHERE o.sku_id='{$sku_id}' AND o.picklist_id IS NULL
		GROUP BY o.sku_id";
		$xres2 = simplexml_load_string($runQuery->RunQuery($Query2));

		$ord_qty= ($xres2->row->cnt2)*1;
		//$sku_id = $xres->row->sku_id;
		$aqty   = ($xres->row->cnt)*1;
		$avaib  = $aqty-$ord_qty;
		$edate  = $xres->row->expiry_date;
		$name   = str_replace('&','and',$xres->row->name);
		$desc   = str_replace('&','and',$xres->row->description);
		$price  = $xres->row->price;
		$cost   = $xres->row->cost;
		if($aqty){$aqty=$aqty;}else{$aqty=0;}
		
		//echo $aqty.' '.$ord_qty.'<br>';
		//echo $sku_id;
		$response .= "<row><SKUID>{$sku_id}</SKUID><EXPDATE>{$edate}</EXPDATE><AvailableQuantity>{$avaib}</AvailableQuantity><PRICE>{$price}</PRICE><COST>{$cost}</COST></row>";
	}
	$response .= "</result>";
	
	echo $response;
	exit;
}
//////     Document Type 3 - Closed	
//////     Document Type 4 - Start
elseif($doctype==4){
	$SD = $xml->AccessRequest->OrderDetail;

	if($SD->ConsigneeName == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Consignee Name Missing</message></result>';
		exit;
	}
	elseif($SD->ConsigneeAddress == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Consignee Address Missing</message></result>';
		exit;
	}
	elseif($SD->ConsigneeEmail == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Consignee Email Missing</message></result>';
		exit;
	}
	elseif($SD->ConsigneeContact == ''){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Consignee Contact Missing</message></result>';
		exit;
	}
	$response = 0;
	foreach($SD->OrderList->Row as $row){
		$CustomerOrderQuantity = $row->SKUQuantity;
		$CustomerSKUID = $row->SKUID;
		$Query = "insert into customer_order_test(order_date,customer_order_id,customer_order_number,sku_id, customer_order_date,customer_billing_name,customer_shipping_name,customer_email,customer_order_quantity,customer_phone,customer_cell,customer_shipping_add) values('".date('Y-m-d')."',$SD->CustomerOrderID,$SD->CustomerOrderNO,'$CustomerSKUID','$SD->CustomerOrderDate','".$SD->ConsigneeName."','".$SD->ConsigneeName."','".$SD->ConsigneeEmail."','$CustomerOrderQuantity','".$SD->ConsigneeContact."','".$SD->ConsigneeContact."','".$SD->ConsigneeAddress."')";
		if($runQuery->RunQuery($Query)){$response=1;}
	}
	if($response == 1){
		echo '<?xml version="1.0" encoding="utf-8"?><result><status>1</status><message>Successfully Received</message></result>';
	}
	else{echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Error! (Not Update)</message></result>';}
	exit;
}
//////     Document Type 4 - Closed	
elseif($doctype==5){
	$response = '<?xml version="1.0" encoding="utf-8"?><result>';
	$Query = "SELECT COUNT(*) AS cnt,inward_detail.sku_id,inward_sku.`expiry_date`,inward_sku.`name`,inward_sku.`description`
	,inward_sku.`price`,inward_sku.`cost`
	FROM inward_detail JOIN inward_sku ON inward_detail.`inward_id`=inward_sku.`inward_id`
	WHERE binid IS NOT NULL
	AND picklist_id IS NULL
	GROUP BY inward_detail.sku_id,inward_sku.`expiry_date`
	ORDER BY inward_sku.`sku_id`";
	$xres = simplexml_load_string($runQuery->RunQuery($Query));
	foreach($xres->row as $row){
		$sku_id = $row->sku_id;
		$aqty   = $row->cnt;
		$edate   = $row->expiry_date;
		$name   = str_replace('&','and',$xres->row->name);
		$desc   = str_replace('&','and',$xres->row->description);
		$price   = $row->price;
		$cost   = $row->cost;
		if($aqty){$aqty=$aqty;}else{$aqty=0;}
		$response .= "<row><SKUID>{$sku_id}</SKUID><EXPDATE>{$edate}</EXPDATE><AvailableQuantity>{$aqty}</AvailableQuantity><PRICE>{$price}</PRICE><COST>{$cost}</COST></row>";
	}
	$response .= "</result>";
	echo $response;
	exit;
}
elseif($doctype==6){
	$response = '<?xml version="1.0" encoding="utf-8"?><result>';
	$Query = "SELECT sku_id,inward_child,binid
	FROM inward_detail 
	WHERE binid IS NOT NULL
	AND picklist_id IS NULL
	and sku_id='".$xml->AccessRequest->SKUID."'
	ORDER BY sku_id";
	$xres = simplexml_load_string($runQuery->RunQuery($Query));
	foreach($xres->row as $row){
		$sku_id = $row->sku_id;
		$whid   = $row->inward_child;
		$bin    = $row->binid;
		$response .= "<row><SKUID>{$sku_id}</SKUID><WHID>{$whid}</WHID><BIN>{$bin}</BIN></row>";
	}
	$response .= "</result>";
	echo $response;
	exit;
}
elseif($doctype==7){
	
	
	
	$response = '<?xml version="1.0" encoding="utf-8"?><result>';
	$ord_id		=	$xml->AccessRequest->ord_id;
	$order_no 	= 	$xml->AccessRequest->refno;
	$order_date = 	$xml->AccessRequest->order_date;
	$skuname	=	$xml->AccessRequest->skuname;
	$skuid		=	$xml->AccessRequest->skuid;
	$brand		=	$xml->AccessRequest->brand;
	$c_order_date=	$xml->AccessRequest->c_order_date;
	$shipname	=	$xml->AccessRequest->shipname;
	$shipcontact =	$xml->AccessRequest->shipcontact;
	$shipaddress	=	$xml->AccessRequest->shipaddress;
	$shipemail		=	$xml->AccessRequest->shipemail;
	$shipcity		=	$xml->AccessRequest->shipcity;
	$shipcountry	=	$xml->AccessRequest->shipcountry;
	$billname	    =	$xml->AccessRequest->billname;
	$billingcontact =	$xml->AccessRequest->billingcontact;
	$billingaddress	=	$xml->AccessRequest->billingaddress;
	$billemail		=	$xml->AccessRequest->billemail;
	$billingcity		=	$xml->AccessRequest->billingcity;
	$billingcountry		=	$xml->AccessRequest->billingcountry;
	$customercomment =	$xml->AccessRequest->customercomment;
	$paymenttype = $xml->AccessRequest->paymenttype;
	$refno  =  $xml->AccessRequest->order_no;
	$couriertype = $xml->AccessRequest->couriertype;
	$singleprice = $xml->AccessRequest->singleprice;
	$productsum =  $xml->AccessRequest->productsum;
	$codamount =  $xml->AccessRequest->codamount;
	$shippingcharges = $xml->AccessRequest->shippingcharges;
	$discountamount = $xml->AccessRequest->discountamount;
	$type		=	$xml->AccessRequest->stype;
	$quantity	=	$xml->AccessRequest->qty;
	$shipment_weight = $xml->AccessRequest->shipment_weight;
	$storeid = $xml->AccessRequest->storeid;
	$totaltax = $xml->AccessRequest->totaltax;
	$actual_price = $xml->AccessRequest->actualpramount;
	$actual_price_with_gst = $xml->AccessRequest->productpriceincludingtax;
	$new_rn_nm = $xml->AccessRequest->new_rn_nm;
	
	if($storeid == 9){
	$storeid = '9221112W';}
	else{
	$storeid = '9221109W';	
	}
	
	
	
	if($couriertype == 'blueex'){$couriertype = 'blueEX';}
	if($couriertype == 'cc'){$couriertype = 'CC';}
	if($couriertype == 'mnp'){$couriertype = 'M&P';}
	
	$qry = "INSERT INTO `customer_order_test`( `order_date`, `customer_order_id`, `customer_order_number`, `sku_id`,
	`customer_order_date`, `customer_billing_name`, `customer_shipping_name`, `customer_email`, `customer_bill_email`,
	`customer_order_quantity`, `sku_name`, `sku_brand`, `customer_phone`, `customer_cell`, `customer_bill_cell`, 
	`customer_shipping_add`, `customer_bill_add`, `customer_bill_city`, `customer_ship_city`, `customer_bill_country`,
	`customer_ship_country`, `shipment_type`, `customer_comment`, `payment_type`, `refno`, `courier_name`,
	`singleprice`, `productsum`, `codamount`, `shippingcharges`, `discountamount`,shipment_weight,storeid,totaltax,actual_price,actual_price_with_gst,random_no) VALUES (NOW(), '$ord_id', '$order_no', 
	'$skuid',NOW(), '$billname', '$shipname','$shipemail','$billemail','$quantity', '$skuname', '$brand'
	,'$shipcontact','$shipcontact','$billcontact','$shipaddress','$billingaddress','$billingcity','$shipcity','$billingcountry',
	'$shipcountry','$type','$customercomment','$paymenttype','$refno','$couriertype','$singleprice','$productsum',
	'$codamount','$shippingcharges','$discountamount','$shipment_weight','$storeid','$totaltax','$actual_price','$actual_price_with_gst','$new_rn_nm')";
	
	$fw = fopen('orderslog/insertqrytest' . date('d-m-Y H:i:s') . '.txt', 'w');
fwrite($fw, $qry);
fclose($fw);
	
	 //API URL for authentication
	
	if($runQuery->RunQuery($qry) == 1){
		$response .= "<status>1</status><message>Saved</message>";
		
		 /*$apiURL="https://staging.khaadi.com/rest/V1/integration/admin/token";
         $data = array("username" => "bluex", "password" => "8LuxIns90zxWxv^@lkY");
         $data_string = json_encode($data);
         $ch = curl_init($apiURL);
         curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
         curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
         curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
         curl_setopt($ch, CURLOPT_HTTPHEADER, array("Content-Type: application/json","Content-Length: ".strlen($data_string)));
         $token = curl_exec($ch);
         $token=  json_decode($token);
		 
		 $qrys = "select inward_detail.sku_id, count(inward_child) as qty from inward_detail left join inward_sku on inward_sku.sku_id = 
		 inward_detail.sku_id where binid is not NULL and picklist_id is NULL AND inward_detail.inprd IS NULL AND inward_detail.`qc_pass` = '0' 
				 AND inward_detail.sku_id = '".$skuid."' group by inward_detail.sku_id order by sku_id DESC";
		$r = $runQuery->RunQuery($qrys);
        $res = simplexml_load_string($r);
		 
		 $qryskus = "Select IFNULL(count(customer_order_quantity),0) AS count from customer_order where sku_id = '".(string)$skuid."'";
         $ress = simplexml_load_string($runQuery->RunQuery($qryskus));
          $count = $ress->row->count; 
		
		$array = array("sku"=>(string)$skuid,"qty"=>(string)$res->row->qty-$count);	
        $request = json_encode($array);
		
		$curl = curl_init();
        curl_setopt_array($curl, array(
        CURLOPT_URL => "https://staging.khaadi.com/rest/V1/BlueEx/updateProductQty",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => "",
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 30,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => "POST",
        CURLOPT_POSTFIELDS => $request,
        CURLOPT_HTTPHEADER => array(
        "authorization: Bearer ".$token,
        "cache-control: no-cache",
        "content-type: application/json"
  ),
));

$responseqty = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);

$fw = fopen('orderslog/updateqty' . date('d-m-Y H:i:s') . '.txt', 'w');
fwrite($fw, $responseqty);
fclose($fw);*/

		
	} else{
		$response .= "<status>0</status><message>Not Saved</message>";
	}
	$response .= "</result>";
	echo $response;
	exit;
}
elseif($doctype==8){
	$response = '<?xml version="1.0" encoding="utf-8"?><result>';
	$Query = "SELECT COUNT(*) AS CNT FROM inward_detail d WHERE d.`binid` IS NOT NULL";
	$xres = simplexml_load_string($runQuery->RunQuery($Query));
	$cnt1 = $xres->row->CNT;
	
	$Query = "SELECT COUNT(*) AS CNT FROM inward_detail d WHERE d.`picklist_id` IS NOT NULL";
	$xres = simplexml_load_string($runQuery->RunQuery($Query));
	$cnt2 = $xres->row->CNT;
	$response .= "<in>".$cnt1."</in>";
	$response .= "<out>".$cnt2."</out>";
	$response .= "</result>";
	echo $response;
	exit;
}

//////     Document Type 9 - Start

elseif($doctype==3){
	$SD = $xml->AccessRequest;

	$response = '<?xml version="1.0" encoding="utf-8"?><result>';
	foreach($SD->SKUList->SKUID as $sku_id){
	
		$Query = "SELECT COUNT(*) AS cnt,inward_detail.sku_id, 
		inward_sku.`name`,inward_sku.`description`
		,inward_sku.`price`,inward_sku.`cost`
		FROM inward_detail JOIN inward_sku ON inward_detail.`inward_id`=inward_sku.`inward_id`
		WHERE picklist_id IS NULL
		and qc_date is null
		and binid is not null
		and inward_detail.sku_id = '{$sku_id}'
		GROUP BY inward_detail.sku_id
		ORDER BY inward_sku.`sku_id`";
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		
		$Query2 = "SELECT SUM(o.customer_order_quantity) AS cnt2 FROM customer_order_test o 
		WHERE o.sku_id='{$sku_id}' 
		AND o.picklist_id in (select picklist_id from picklist_master where picklist_status is null)
		GROUP BY o.sku_id";
		
		//AND o.picklist_id IS NULL
		
		$xres2 = simplexml_load_string($runQuery->RunQuery($Query2));

		$Query3 = "SELECT SUM(o.customer_order_quantity) AS cnt3 FROM customer_order o 
		WHERE o.sku_id='{$sku_id}' 
		AND o.picklist_id IS NULL
		GROUP BY o.sku_id";
		
		//AND o.picklist_id IS NULL
		
		$xres3 = simplexml_load_string($runQuery->RunQuery($Query3));

		$blk_qty= ($xres3->row->cnt3)*1;
		if(is_null($blk_qty)){$blk_qty=0;}
		
		$ord_qty= ($xres2->row->cnt2)*1;
		if(is_null($ord_qty)){$ord_qty=0;}
		
		//$sku_id = $xres->row->sku_id;
		
		$aqty   = ($xres->row->cnt)*1;
		if(is_null($aqty)){$aqty=0;}
		
		$avaib  = ($aqty-$ord_qty)-$blk_qty;
		
		if($avaib<0) {$avaib=0;}
		$edate  = $xres->row->expiry_date;
		$name   = str_replace('&','and',$xres->row->name);
		$desc   = str_replace('&','and',$xres->row->description);
		$price  = $xres->row->price;
		$cost   = $xres->row->cost;
		if($aqty){$aqty=$aqty;}else{$aqty=0;}
		
		//echo $aqty.' '.$ord_qty.'<br>';
		//echo $sku_id;
		$response .= "<row><SKUID>{$sku_id}</SKUID><EXPDATE>{$edate}</EXPDATE><AvailableQuantity>{$avaib}</AvailableQuantity><PRICE>{$price}</PRICE><COST>{$cost}</COST></row>";
	}
	$response .= "</result>";
	
	echo $response;
	exit;
}

//////     Document Type 9 - Closed	

//////     Document Type 10 - Start

elseif($doctype==10){
	
		$Query = "SELECT ins.`sku_id`, (SELECT COUNT(id.inward_child) FROM inward_detail id WHERE id.sku_id = ins.`sku_id` AND picklist_id IS NULL AND qc_date IS NULL AND binid IS NOT NULL) AS cnt FROM inward_sku ins WHERE ins.`acno` = 'KHI-03235' GROUP BY ins.`sku_id`";
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		
		$response = "<result>";
		foreach ($xres->row as $key => $value) {
			$sku_id = $value->sku_id;
			$aqty   = ($value->cnt)*1;
			$response .= "<row><SKUID>{$sku_id}</SKUID><AvailableQuantity>{$aqty}</AvailableQuantity></row>";
		}
		$response .= "</result>";
		
		//echo $aqty.' '.$ord_qty.'<br>';
		//echo $sku_id;
	
	echo $response;
	exit;
}


//////     Document Type 11 - Start
elseif($doctype==11){
		
		// $Query = "SELECT ins.`sku_id`, COUNT(ind.`inward_child`) AS qty, ins.`price`, ind.`inward_id` FROM inward_sku ins JOIN inward_detail ind ON ind.`inward_id` = ins.`inward_id` WHERE ins.acno = 'KHI-03235' AND ind.`picklist_id` IS NULL  AND ind.`binid` IS NOT NULL AND ind.`qc_pass` = 0 AND ind.`inprd` IS NULL GROUP BY ins.`sku_id` ORDER BY ind.`inward_id`";
		$sdate = $xml->AccessRequest->StartDate;
		$edate = $xml->AccessRequest->EndDate;
		$limit = $xml->AccessRequest->Limit;
		$Query = "SELECT ins.`sku_id`,(COUNT(ind.`inward_child`) - (SELECT COUNT(ind1.`inward_child`) AS qty FROM inward_detail ind1 WHERE ind1.prdis_date >= '$sdate' AND ind1.prdis_date <= '$edate' AND ind1.sku_id = ind.`sku_id` AND ind1.`inprd` IS NOT NULL) - (SELECT COUNT(ind1.`inward_child`) AS qty FROM inward_detail ind1 WHERE ind1.qc_date >= '$sdate' AND ind1.qc_date <= '$edate' AND ind1.`qc_pass` = '1' AND ind1.sku_id = ind.`sku_id`) - (SELECT COUNT(ind1.`inward_child`) AS qty FROM inward_detail ind1 WHERE ind1.sku_id = ind.`sku_id` AND ind1.`stack_date` >= '$sdate' AND ind1.`stack_date` <= '$edate' AND ind1.`picklist_id` IN (SELECT pm.`picklist_id` FROM picklist_master pm WHERE pm.`picklist_date` >= '$sdate' AND pm.`picklist_date` <= '$edate' AND pm.`picklist_status` = 1) )) AS qty,ins.`price`,ind.`inward_id` FROM inward_sku ins JOIN inward_detail ind ON ind.`inward_id` = ins.`inward_id` where sku_date >= '$sdate' and sku_date <= '$edate' and ins.acno = 'KHI-03235' AND ind.`binid` IS NOT NULL GROUP BY ins.`sku_id` ORDER BY ind.`inward_id` LIMIT $limit, 20";
		//echo $Query;
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		
		$response = "<result>";
		foreach ($xres->row as $key => $value) {
			$sku_id = $value->sku_id;
			$aqty   = ($value->qty)*1;
			$response .= "<row><SKUID>{$sku_id}</SKUID><AvailableQuantity>{$aqty}</AvailableQuantity></row>";
		}
		$response .= "</result>";
		
		//echo $aqty.' '.$ord_qty.'<br>';
		// echo $sku_id;
	
	echo $response;
	exit;
}

//////     Document Type 12 - Start
elseif($doctype==12){
		$sdate = $xml->AccessRequest->StartDate;
		$edate = $xml->AccessRequest->EndDate;
		$Query = "SELECT id.`sku_id`, ins.`brand`, ins.`categories`,ins.`description`, id.`binid`, COUNT(DISTINCT id.`inward_child`) AS qty, ins.`price`, ins.`cost`, id.`stack_date` FROM inward_detail id JOIN inward_sku ins ON id.`sku_id` = ins.`sku_id` WHERE ins.acno = 'KHI-03235' AND id.`qc_pass` = 0 AND id.`inprd` IS NULL AND binid IS NOT NULL AND (DATE(id.`stack_date`) BETWEEN STR_TO_DATE('$sdate', '%d/%m/%Y') AND STR_TO_DATE('$edate', '%d/%m/%Y')) GROUP BY id.`stack_date`, id.`sku_id` ORDER BY stack_date";
		
		echo $runQuery->RunQuery($Query);
	exit;
}


//////     Document Type 13 - Start
elseif($doctype==13){		
		$Query = "SELECT ins.`sku_id`, COUNT(ind.`inward_child`) AS qty, ins.`price`, ind.`inward_id` FROM inward_sku ins JOIN inward_detail ind ON ind.`inward_id` = ins.`inward_id` WHERE ins.acno = 'KHI-03235' AND ind.`picklist_id` IS NULL  AND ind.`binid` IS NOT NULL AND ind.`qc_pass` = 0 AND ind.`inprd` IS NULL GROUP BY ins.`sku_id` ORDER BY ind.`inward_id`";
		
		$xres = simplexml_load_string($runQuery->RunQuery($Query));
		
		$response = "<result>";
		foreach ($xres->row as $key => $value) {
			$sku_id = $value->sku_id;
			$aqty   = ($value->qty)*1;
			$response .= "<row><SKUID>{$sku_id}</SKUID><AvailableQuantity>{$aqty}</AvailableQuantity></row>";
		}
		$response .= "</result>";
		
		//echo $aqty.' '.$ord_qty.'<br>';
		// echo $sku_id;
	
	echo $response;
	exit;
}
//////     Document Type 9 - Closed	

else{echo '<?xml version="1.0" encoding="utf-8"?><result><status>0</status><message>Error! (Wrong Document Type)</message></result>';}	
?>